import 'enums.dart';

abstract class FontFamily {
  String? get name;
  Iterable<FontStyle>? get styles;
}

abstract class GoogleFontFamily implements FontFamily {}

abstract class FontStyle {
  String? get name;
  FontWeight? get weight;
  bool? get italic;
  FontFamily? get family;
}

class GoogleFontFamilyImpl implements GoogleFontFamily {
  GoogleFontFamilyImpl(this.name, {Iterable<FontStyle>? styles}) {
    if (styles != null) {
      this.styles.addAll(styles);
    }
  }

  @override
  final String name;
  @override
  final Set<FontStyle> styles = {};
}

class FontStyleImpl extends FontStyle {
  FontStyleImpl(this.family, this.name, this.weight, {this.italic = false}) {
    family.styles.add(this);
  }

  @override
  final String name;
  @override
  final FontWeight weight;
  @override
  bool italic;
  @override
  final GoogleFontFamilyImpl family;
}
