import 'dart:async';
import 'dart:js';
import 'interface.dart';

Future loadFont(Options options) {
  final cmp = Completer();
  final act = options.active;
  final inact = options.inactive;

  options
    ..active = allowInterop(() {
    act?.call();
    cmp.complete();
  })
  ..inactive = allowInterop(() {
    inact?.call();
    cmp.completeError('Inactivated');
  });


  load(options);

  return cmp.future;
}
