@JS('WebFont')
library web_font;

import 'dart:async';

import 'package:js/js.dart';
import 'package:js_interop/js_interop.dart';

import '../assets/webfont.dart' as bundle;

typedef SimpleEvent = void Function();

Future<bool> enableWebFontLoader() => JsInterop.safeAddScript('WebFont',
    bundle.buffer);

@JS()
external void load(Options options);

@JS()
@anonymous
class Options {
  external SimpleEvent? get active;
  external set active(SimpleEvent? value);
  external SimpleEvent? get inactive;
  external set inactive(SimpleEvent? value);
  external SimpleEvent? get loading;
  external set loading(SimpleEvent? value);

  external factory Options({
    GoogleFonts google,
    SimpleEvent active,
    SimpleEvent inactive,
    SimpleEvent loading,
  });
}

@JS()
@anonymous
class GoogleFonts {
  external factory GoogleFonts({
    List<String> families
  });
}


